
#include <ESP8266WiFi.h>
#include <WiFiClientSecure.h>
#include "DHT.h"

  #include "DHT.h"
  #define DHTTYPE DHT11                                         // Выбор датчика температуры (DHT11, DHT21, and DHT22)
  const int DHTPin = D1;                                        // Датчик DHT11 подключен к D1(GPIO5)
  DHT dht(DHTPin, DHTTYPE);                                     // Инициализируем DHT датчик, в скобках пин и тип датчика
  
  const char* ssid = "XXXXX";                                   // Название WIFIсети
  const char* password = "XXXXXXXX";                            // Пароль WIFI сети
  
  const char* host = "script.google.com";                       //Host Google
  const int httpsPort = 443;                                    //Port Google
  
  WiFiClientSecure client;                                      // Создание объекта WiFiClientSecure
    
  String Google_ID = "AKfycbzNX9Phkw-4lPZDRc6_su8a5XXXXcoGj0XAEHke-XXXXXXXX-XX"; // script ID Гугл таблицы
   
  unsigned long last_time;                                      
  const int pausa = 600000;                                      // Обновление температуры 1 минута
  #define ON_Board_LED 2                                        // Светодиод на плате

void setup() {
  Serial.begin(115200);
  dht.begin();                                                  // Запускаем датчик DHT11
  delay(500);  
  WiFi.begin(ssid, password);                                   // Соединение с WiFi роутером
    
  pinMode(ON_Board_LED,OUTPUT);                                 // Светодиод на плате объявляем как выход
  digitalWrite(ON_Board_LED, HIGH);                             // Гасим светодиод
  
//Ожидаем подключения
  Serial.print("Подключение ");
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
// Мигаем светодиодом пока идёт соединение с роутером
    digitalWrite(ON_Board_LED, LOW);
    delay(250);
    digitalWrite(ON_Board_LED, HIGH);
    delay(250);
  }
  digitalWrite(ON_Board_LED, HIGH);                             // Гасим светодиод
  
  Serial.println("");
  Serial.print("Успешно подключено к : ");
  Serial.println(ssid);
  Serial.print("IP адрес: ");
  Serial.println(WiFi.localIP());
  Serial.println();
  client.setInsecure();
}

void loop() {
  int h = dht.readHumidity();                                     // Сохраняем в переменную Влажность
  // Read temperature as Celsius (the default)
  float t = dht.readTemperature();                                // Сохраняем в переменную Температуру
  
  if (isnan(h) || isnan(t)) {
    Serial.println("Ошибка чтения датчика температуры ");
    delay(500);
    return;
  }
  String Temp = "Температура : " + String(t) + " °C";
  String Humi = "Влажность : " + String(h) + " %";
  
  if(millis() - last_time > pausa) {                             // Пауза в выводе температуры
    sendData(t, h);                                              // Вызывает подпрограмму sendData
    last_time = millis();
  } 
}

void sendData(float tem, int hum) {
  if (!client.connect(host, httpsPort)) {
    Serial.println("Ошибка соединения");
    return;
  }
 
// Формируем запрос на отправку данных
// https://script.google.com/macros/s/AKfycbzNX9Phkw-4lPZDRc6_su8a5XXXXcoGj0XAEHke-XXXXXXXX-XX/exec?temperature=22&humidity=57
  String string_temperature =  String(tem);
  // String string_temperature =  String(tem, DEC); 
  String string_humidity =  String(hum, DEC); 
  String url = "/macros/s/" + Google_ID + "/exec?temperature=" + string_temperature + "&humidity=" + string_humidity;
  Serial.print("Адрес URL: ");
  Serial.println(url);

  client.print(String("GET ") + url + " HTTP/1.1\r\n" +
         "Host: " + host + "\r\n" +
         "User-Agent: BuildFailureDetectorESP8266\r\n" +
         "Connection: close\r\n\r\n");

  Serial.println("Запрос отправлен"); 
} 
